unit CD84sau;

(*Why this application was written. How it works.

Ever been asked to type something like "ABC01ol" into a computer,
to gain access to something? Is that "ABC zero one oh ell"? Or
some other mix of ohs and zeros, ones and ells?

This application will take a string of any printable characters,
and even some characters that aren't "printable" (e.g. a space, or a TAB)
and convert them into a second string... one that does not contain
any troublemakers! You can quite easily modify the code to re-define
"troublemaker".

The resulting string will sometimes be longer than the original... but often it
will not be much longer.

The "code" is not very complex. Don't use it to hide text. But you can use
it to make something that has already been scrambled by another application
harder to mistype.

The application includes a de-coding routine, so that you can get back the
original string, should you need it, say within the application the string
has been typed into.

The method is an extended version of the following. To follow the example,
remember that the ascii for "0" (zero), in hex, is 30, and the ascii for
"o" (lower case oh), in hex, is  6F, and the ascii for "+", in hex is 2B.

Soemthing you don't have to understand, but may help some readers:
We're simple going to use an escape character. (Don't worry if
that doesn't mean anything to you.)

The string ABCo0567+XYZ, when run through my system, becomes...

ABC+gw+da567+2bXYZ

... if the encoding string (more on this in a moment) is...

These letters:                 abcdefghjkmnprtw  <-- note that not every letter has been used
To stand for these characters: 0123456789abcdef

There's only one little bit of "cleverness" in this program.

The unclever bit is as follows: To make the output, just transcribe the input,]
one character at a time. If you get to one of the "unacceptable" characters,
replace it with a plus sign, and two characters which stand for the replaced
character's ascii code in hex.

The clever bit is to remember that the plus sign itself must be shown the way
the unacceptable characters are shown. (Otherwise you don't know if a plus sign
means "a plus sign", or means "make a character out of the next two characters,
using the ascii table."

Encoding string:

This is just 16 characters which are going to stand for the sixteen hex digits,
0-9, a-f. They can be any characters you like... as long as none of the
unaccesptable characters (like 0 and O), and the escape character ("+", as this
has been presented) are included in the set.

*)

interface

uses dialogs;

var cEscU,sHexSubsU,sNotAllowedU:string;

function bSetAndCheckAreNoBadConstantsOkay(cEscT,
         sHexSubsT,sNotAllowedT:string):byte;
function sNoBadChars(sSource:string):string;
function sBackToAmbig(sSource:string):string;

implementation

function bSetAndCheckAreNoBadConstantsOkay(cEscT,
         sHexSubsT,sNotAllowedT:string):byte;
begin
cEscU:=cEscT;
sHexSubsU:=sHexSubsT;
sNotAllowedU:=sNotAllowedT;
result:=0;
if pos(cEscU,sNotAllowedU)<>0 then result:=1;
//other checks to be added later. See CD83.
end;

function sNoBadChars(sSource:string):string;
var c1,iHowMany:integer;
    sResult,s1:string;
    b1,b2,bWhole:byte;
begin
if cEscU='xxSetupNotCalledYetxx' then
     showmessage('Error: sSetAndCheck... should have been called before this was.');
sResult:='';
iHowMany:=length(sSource);
for c1 := 1 to iHowMany do begin
   s1:=sSource[c1];
   if pos(s1,sNotAllowedU)=0 then {do nothing} else begin
      bWhole:=ord(s1[1]);
      b1:=bWhole div 16+1;(*"+1" so that zero is translated to the
             first (1th) character in cHexSubs, "1" is translated to
             the 2nd character, etc.*)
      b2:=bWhole and $0F+1;
      s1:=cEscU+copy(sHexSubsU,b1,1)+copy(sHexSubsU,b2,1);
      end;//else
   sResult:=sResult+s1;
   end;//for
result:=sResult;
end;// sNoBadChars

function sBackToAmbig(sSource:string):string;
var c1,iHowMany:integer;
    sResult,s1:string;
    b1,b2:byte;
begin
if cEscU='xxSetupNotCalledYetxx' then
     showmessage('Error: sSetAndCheck... should have been called before this was.');
sResult:='';
iHowMany:=length(sSource);
c1:=1;
repeat //for loop replaced by near equivalent so index can be manipulated within loop
   s1:=sSource[c1];
  if s1=cEscU then begin
      b1:=pos(sSource[c1+1],sHexSubsU)-1;
      b2:=pos(sSource[c1+2],sHexSubsU)-1;
      c1:=c1+2;//This is the line that meant the "for" loop had to be replaced
      //This line was useful while I was getting evreything right! --> showmessage(inttostr(b1)+' '+inttostr(b2));
      s1:=chr(b1*16+b2);
      end;//then...
   sResult:=sResult+s1;
   inc(c1);
   until c1> iHowMany;
result:=sResult;
end;//sNoBadChars

initialization
cEscU:='xxSetupNotCalledYetxx';// rogue value.

end.
